module ServicePacker::Core
  class Validation
    def initialize(name, *args, &block)
      @name = name
      @args = args
      @block = block
    end

    def invoke(record, *args)
      result = record.instance_exec(*args, &block)
      if (result.respond_to?(:errors) && result.errors.empty?) || result == true
        true
      else
        false
      end
    end

    attr_reader :name, :args, :block, :result

  end
end
